All of lore.kernel.org
 help / color / mirror / Atom feed
* [PATCH 1/3] Check pwrite parameters
@ 2017-11-27 18:49 Goldwyn Rodrigues
  2017-11-27 18:49 ` [PATCH v2 2/3] generic/470: Test RWF_NOWAIT Goldwyn Rodrigues
                   ` (2 more replies)
  0 siblings, 3 replies; 6+ messages in thread
From: Goldwyn Rodrigues @ 2017-11-27 18:49 UTC (permalink / raw)
  To: fstests; +Cc: darrick.wong, Goldwyn Rodrigues

From: Goldwyn Rodrigues <rgoldwyn@suse.com>

There are some parameters added with xfs_io. Check if the pwrite
parameters are available. For some cases, xfs_io now returns "command
-%c not supported", so added "not supported" to count as error.

Signed-off-by: Goldwyn Rodrigues <rgoldwyn@suse.com>
---
 common/rc | 10 +++++++++-
 1 file changed, 9 insertions(+), 1 deletion(-)

diff --git a/common/rc b/common/rc
index 4c053a53..b6778f07 100644
--- a/common/rc
+++ b/common/rc
@@ -2079,6 +2079,14 @@ _require_xfs_io_command()
 		echo $testio | grep -q "invalid option" && \
 			_notrun "xfs_io $command support is missing"
 		;;
+	"pwrite")
+		if [ "$param" == "-N" ]; then
+			opts="-d"
+		fi
+		testio=`$XFS_IO_PROG -f $opts -c "pwrite $param 0 1M" \
+			$testfile 2>&1`
+		param_checked=1
+		;;
 	"scrub"|"repair")
 		testio=`$XFS_IO_PROG -x -c "$command probe 0" $TEST_DIR 2>&1`
 		echo $testio | grep -q "Inappropriate ioctl" && \
@@ -2109,7 +2117,7 @@ _require_xfs_io_command()
 		$XFS_IO_PROG -c "help $command" | grep -q "^ $param --" || \
 			_notrun "xfs_io $command doesn't support $param"
 	else
-		echo $testio | grep -q "invalid option" && \
+		echo $testio | grep -q "\(invalid option\|not supported\)" && \
 			_notrun "xfs_io $command doesn't support $param"
 	fi
 }
-- 
2.14.2


^ permalink raw reply related	[flat|nested] 6+ messages in thread

* [PATCH v2 2/3] generic/470: Test RWF_NOWAIT
  2017-11-27 18:49 [PATCH 1/3] Check pwrite parameters Goldwyn Rodrigues
@ 2017-11-27 18:49 ` Goldwyn Rodrigues
  2017-11-29 10:25   ` Eryu Guan
  2017-11-27 18:49 ` [PATCH v2 3/3] generic/471: Partial direct write test Goldwyn Rodrigues
  2017-11-29  9:49 ` [PATCH 1/3] Check pwrite parameters Eryu Guan
  2 siblings, 1 reply; 6+ messages in thread
From: Goldwyn Rodrigues @ 2017-11-27 18:49 UTC (permalink / raw)
  To: fstests; +Cc: darrick.wong, Goldwyn Rodrigues

From: Goldwyn Rodrigues <rgoldwyn@suse.com>

Tests the RWF_NOWAIT flag so the I/O returns immediately with -EAGAIN
on a new file since it requires block allocation.

It creates a file, syncs it, and overwrites the file with RWF_NOWAIT.
This should succeed.

Finally, read the contents to make sure the overwrite is successful.

Signed-off-by: Goldwyn Rodrigues <rgoldwyn@suse.com>

Changes since v1:
 - Fix testdir name
 - use of $XFS_IO_PROG instead of xfs_io
 - check pwrite accepts -N

---
 tests/generic/470     | 74 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/470.out | 13 +++++++++
 tests/generic/group   |  1 +
 3 files changed, 88 insertions(+)
 create mode 100755 tests/generic/470
 create mode 100644 tests/generic/470.out

diff --git a/tests/generic/470 b/tests/generic/470
new file mode 100755
index 00000000..7439dfd3
--- /dev/null
+++ b/tests/generic/470
@@ -0,0 +1,74 @@
+#! /bin/bash
+# FS QA Test No. 470
+#
+# write() to a file opened with O_DIRECT with count > remaining
+# bytes. Result should be remaining bytes (to aligned bytes) instead
+# of ENOSPC error
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017, SUSE Linux Products.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -rf $tmp.* $testdir
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/populate
+. ./common/filter
+. ./common/attr
+
+# real QA test starts here
+_supported_os Linux
+_require_odirect
+_require_scratch
+_require_xfs_io_command pwrite -N
+
+_scratch_mkfs > /dev/null 2>&1
+_scratch_mount > /dev/null 2>&1
+testdir=$SCRATCH_MNT/test-$seq
+mkdir $testdir
+
+# Create a file with pwrite nowait (will fail with EAGAIN)
+$XFS_IO_PROG -f -d -c "pwrite -N -V 1 -b 128M 0 128M" $testdir/f1
+
+# Write the file without nowait
+$XFS_IO_PROG -f -d -c "pwrite -S 0xaa -W -w -V 1 -b 128M 0 128M" $testdir/f1 | _filter_xfs_io
+
+time_taken=`$XFS_IO_PROG -d -c "pwrite -S 0xbb -N -V 1 -b 1M 4M 1M" $testdir/f1 | awk '/^1/ {print $5}'`
+if (( $(echo "$time_taken < 0.05" | bc -l) )); then
+	echo "RWF_NOWAIT time is within limits."
+else
+	echo "RWF_NOWAIT took $time_taken seconds"
+fi
+
+$XFS_IO_PROG -c "pread -v 0 128M" $testdir/f1 | _filter_xfs_io_unique
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/470.out b/tests/generic/470.out
new file mode 100644
index 00000000..6d47b219
--- /dev/null
+++ b/tests/generic/470.out
@@ -0,0 +1,13 @@
+QA output created by 470
+pwrite: Resource temporarily unavailable
+wrote 134217728/134217728 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
+RWF_NOWAIT time is within limits.
+00000000:  aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa  ................
+*
+00400000:  bb bb bb bb bb bb bb bb bb bb bb bb bb bb bb bb  ................
+*
+00500000:  aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa  ................
+*
+read 134217728/134217728 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
diff --git a/tests/generic/group b/tests/generic/group
index 6c3bb03a..11ccfb01 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -472,3 +472,4 @@
 467 auto quick exportfs
 468 shutdown auto quick metadata
 469 auto quick
+470 auto quick
-- 
2.14.2


^ permalink raw reply related	[flat|nested] 6+ messages in thread

* [PATCH v2 3/3] generic/471: Partial direct write test
  2017-11-27 18:49 [PATCH 1/3] Check pwrite parameters Goldwyn Rodrigues
  2017-11-27 18:49 ` [PATCH v2 2/3] generic/470: Test RWF_NOWAIT Goldwyn Rodrigues
@ 2017-11-27 18:49 ` Goldwyn Rodrigues
  2017-11-29 10:46   ` Eryu Guan
  2017-11-29  9:49 ` [PATCH 1/3] Check pwrite parameters Eryu Guan
  2 siblings, 1 reply; 6+ messages in thread
From: Goldwyn Rodrigues @ 2017-11-27 18:49 UTC (permalink / raw)
  To: fstests; +Cc: darrick.wong, Goldwyn Rodrigues

From: Goldwyn Rodrigues <rgoldwyn@suse.com>

Getting an error midway through a direct write would return an error
and the error-code is returned in the write() call. However, partial
data is over-written during the call.

This tests simulates the ENOSPC error to check for partial direct
write consistency.

Signed-off-by: Goldwyn Rodrigues <rgoldwyn@suse.com>

Changes since v1:
 - Check for option pwrite -O
 - Create a 200M file instead of multiple 40M files.

---
 tests/generic/471     | 90 +++++++++++++++++++++++++++++++++++++++++++++++++++
 tests/generic/471.out |  9 ++++++
 tests/generic/group   |  1 +
 3 files changed, 100 insertions(+)
 create mode 100755 tests/generic/471
 create mode 100644 tests/generic/471.out

diff --git a/tests/generic/471 b/tests/generic/471
new file mode 100755
index 00000000..a7780af1
--- /dev/null
+++ b/tests/generic/471
@@ -0,0 +1,90 @@
+#! /bin/bash
+# FS QA Test No. 471
+#
+# write() to a file opened with O_DIRECT with count > remaining
+# bytes. In case of a bug, the write returns ENOSPC wheras the
+# showing no data is written, but the file contents are updated.
+# Result should be the write should return remaining bytes
+# (to aligned bytes) instead of ENOSPC error.
+#
+#-----------------------------------------------------------------------
+# Copyright (c) 2017, SUSE Linux Products.  All Rights Reserved.
+#
+# This program is free software; you can redistribute it and/or
+# modify it under the terms of the GNU General Public License as
+# published by the Free Software Foundation.
+#
+# This program is distributed in the hope that it would be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write the Free Software Foundation,
+# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+#-----------------------------------------------------------------------
+
+seq=`basename $0`
+seqres=$RESULT_DIR/$seq
+echo "QA output created by $seq"
+
+here=`pwd`
+tmp=/tmp/$$
+status=1    # failure is the default!
+trap "_cleanup; exit \$status" 0 1 2 3 15
+
+_cleanup()
+{
+    cd /
+    rm -rf $tmp.* $testdir1
+}
+
+# get standard environment, filters and checks
+. ./common/rc
+. ./common/populate
+. ./common/filter
+. ./common/attr
+
+# real QA test starts here
+_supported_os Linux
+_require_odirect
+_require_xfs_io_command pwrite -O
+
+rm -f $seqres.full
+
+echo "Reformat with 320M size"
+umount $SCRATCH_MNT
+sz_bytes=$((320 * 1024 * 1024))
+_scratch_mkfs_sized $sz_bytes >> $seqres.full 2>&1
+_scratch_mount >> $seqres.full 2>&1
+testdir=$SCRATCH_MNT/test-$seq
+rm -rf $testdir
+mkdir $testdir
+sync
+
+#Almost fill the filesystem
+echo "Almost fill the filesystem"
+$XFS_IO_PROG -f -c "pwrite 0 200M" $testdir/f1 > /dev/null
+
+# Create a file using buffered I/O which succeeds only partially
+$XFS_IO_PROG -f -c "pwrite -w -S 0xaa 0 128M" $testdir/partial
+
+# re-write using direct I/O with another pattern using one single buffer, once
+write_size=`$XFS_IO_PROG -d -c "pwrite -O -S 0xcd -V 1 -b 128M 0 128M" $testdir/partial | awk '/^wrote/ {split($2, bytes, "/"); print bytes[1]}'`
+if [ -z $write_size ]; then
+	write_size=0
+fi
+
+# If bug is not fixed, pwrite will return error and but still write data
+if [ $write_size -gt 0 ]; then
+	echo "pwrite wrote more than zero bytes."
+else
+	echo "pwrite wrote zero bytes"
+fi
+
+# read the partial file to check if data written is of last write
+$XFS_IO_PROG -c "pread 0 2M -v" $testdir/partial | _filter_xfs_io_unique
+
+# success, all done
+status=0
+exit
diff --git a/tests/generic/471.out b/tests/generic/471.out
new file mode 100644
index 00000000..e01687c8
--- /dev/null
+++ b/tests/generic/471.out
@@ -0,0 +1,9 @@
+QA output created by 471
+Reformat with 320M size
+Almost fill the filesystem
+pwrite: No space left on device
+pwrite wrote more than zero bytes.
+00000000:  cd cd cd cd cd cd cd cd cd cd cd cd cd cd cd cd  ................
+*
+read 2097152/2097152 bytes at offset 0
+XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
diff --git a/tests/generic/group b/tests/generic/group
index 11ccfb01..f4591620 100644
--- a/tests/generic/group
+++ b/tests/generic/group
@@ -473,3 +473,4 @@
 468 shutdown auto quick metadata
 469 auto quick
 470 auto quick
+471 auto quick rw
-- 
2.14.2


^ permalink raw reply related	[flat|nested] 6+ messages in thread

* Re: [PATCH 1/3] Check pwrite parameters
  2017-11-27 18:49 [PATCH 1/3] Check pwrite parameters Goldwyn Rodrigues
  2017-11-27 18:49 ` [PATCH v2 2/3] generic/470: Test RWF_NOWAIT Goldwyn Rodrigues
  2017-11-27 18:49 ` [PATCH v2 3/3] generic/471: Partial direct write test Goldwyn Rodrigues
@ 2017-11-29  9:49 ` Eryu Guan
  2 siblings, 0 replies; 6+ messages in thread
From: Eryu Guan @ 2017-11-29  9:49 UTC (permalink / raw)
  To: Goldwyn Rodrigues; +Cc: fstests, darrick.wong, Goldwyn Rodrigues

On Mon, Nov 27, 2017 at 12:49:18PM -0600, Goldwyn Rodrigues wrote:
> From: Goldwyn Rodrigues <rgoldwyn@suse.com>
> 
> There are some parameters added with xfs_io. Check if the pwrite
> parameters are available. For some cases, xfs_io now returns "command
> -%c not supported", so added "not supported" to count as error.
> 
> Signed-off-by: Goldwyn Rodrigues <rgoldwyn@suse.com>
> ---
>  common/rc | 10 +++++++++-
>  1 file changed, 9 insertions(+), 1 deletion(-)
> 
> diff --git a/common/rc b/common/rc
> index 4c053a53..b6778f07 100644
> --- a/common/rc
> +++ b/common/rc
> @@ -2079,6 +2079,14 @@ _require_xfs_io_command()
>  		echo $testio | grep -q "invalid option" && \
>  			_notrun "xfs_io $command support is missing"
>  		;;
> +	"pwrite")
> +		if [ "$param" == "-N" ]; then
> +			opts="-d"

I think we'd need some comments on why direct I/O is needed for "-N"
option. And better to declare 'opts' as a local variable.

> +		fi
> +		testio=`$XFS_IO_PROG -f $opts -c "pwrite $param 0 1M" \
> +			$testfile 2>&1`
> +		param_checked=1
> +		;;
>  	"scrub"|"repair")
>  		testio=`$XFS_IO_PROG -x -c "$command probe 0" $TEST_DIR 2>&1`
>  		echo $testio | grep -q "Inappropriate ioctl" && \
> @@ -2109,7 +2117,7 @@ _require_xfs_io_command()
>  		$XFS_IO_PROG -c "help $command" | grep -q "^ $param --" || \
>  			_notrun "xfs_io $command doesn't support $param"
>  	else
> -		echo $testio | grep -q "invalid option" && \
> +		echo $testio | grep -q "\(invalid option\|not supported\)" && \

Need comments on the "not supported" case, because we've checked
"Operation not supported" case above, it's a bit confusing why the two
"not supported" can't be merged into one.

Thanks,
Eryu

>  			_notrun "xfs_io $command doesn't support $param"
>  	fi
>  }
> -- 
> 2.14.2
> 
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

^ permalink raw reply	[flat|nested] 6+ messages in thread

* Re: [PATCH v2 2/3] generic/470: Test RWF_NOWAIT
  2017-11-27 18:49 ` [PATCH v2 2/3] generic/470: Test RWF_NOWAIT Goldwyn Rodrigues
@ 2017-11-29 10:25   ` Eryu Guan
  0 siblings, 0 replies; 6+ messages in thread
From: Eryu Guan @ 2017-11-29 10:25 UTC (permalink / raw)
  To: Goldwyn Rodrigues; +Cc: fstests, darrick.wong, Goldwyn Rodrigues

On Mon, Nov 27, 2017 at 12:49:19PM -0600, Goldwyn Rodrigues wrote:
> From: Goldwyn Rodrigues <rgoldwyn@suse.com>
> 
> Tests the RWF_NOWAIT flag so the I/O returns immediately with -EAGAIN
> on a new file since it requires block allocation.
> 
> It creates a file, syncs it, and overwrites the file with RWF_NOWAIT.
> This should succeed.
> 
> Finally, read the contents to make sure the overwrite is successful.
> 
> Signed-off-by: Goldwyn Rodrigues <rgoldwyn@suse.com>
> 
> Changes since v1:
>  - Fix testdir name
>  - use of $XFS_IO_PROG instead of xfs_io
>  - check pwrite accepts -N
> 
> ---
>  tests/generic/470     | 74 +++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/470.out | 13 +++++++++
>  tests/generic/group   |  1 +
>  3 files changed, 88 insertions(+)
>  create mode 100755 tests/generic/470
>  create mode 100644 tests/generic/470.out
> 
> diff --git a/tests/generic/470 b/tests/generic/470
> new file mode 100755
> index 00000000..7439dfd3
> --- /dev/null
> +++ b/tests/generic/470
> @@ -0,0 +1,74 @@
> +#! /bin/bash
> +# FS QA Test No. 470
> +#
> +# write() to a file opened with O_DIRECT with count > remaining
> +# bytes. Result should be remaining bytes (to aligned bytes) instead
> +# of ENOSPC error

Wrong test description? It seems for generic/471.

> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2017, SUSE Linux Products.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#-----------------------------------------------------------------------
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1    # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +    cd /
> +    rm -rf $tmp.* $testdir
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/populate
> +. ./common/filter
> +. ./common/attr
> +
> +# real QA test starts here
> +_supported_os Linux
> +_require_odirect
> +_require_scratch

I think this test can be run on $TEST_DEV directly, so _require_test
here and do all the tests in $TEST_DIR would be fine.

> +_require_xfs_io_command pwrite -N
> +
> +_scratch_mkfs > /dev/null 2>&1
> +_scratch_mount > /dev/null 2>&1
> +testdir=$SCRATCH_MNT/test-$seq
> +mkdir $testdir
> +
> +# Create a file with pwrite nowait (will fail with EAGAIN)
> +$XFS_IO_PROG -f -d -c "pwrite -N -V 1 -b 128M 0 128M" $testdir/f1
> +
> +# Write the file without nowait
> +$XFS_IO_PROG -f -d -c "pwrite -S 0xaa -W -w -V 1 -b 128M 0 128M" $testdir/f1 | _filter_xfs_io

Hmm, any reason using 128M block size? I'm afraid it will cause problems
when memory is low.

> +
> +time_taken=`$XFS_IO_PROG -d -c "pwrite -S 0xbb -N -V 1 -b 1M 4M 1M" $testdir/f1 | awk '/^1/ {print $5}'`
> +if (( $(echo "$time_taken < 0.05" | bc -l) )); then
> +	echo "RWF_NOWAIT time is within limits."
> +else
> +	echo "RWF_NOWAIT took $time_taken seconds"
> +fi

This looks fragile to me, at least this needs a big comment.

> +
> +$XFS_IO_PROG -c "pread -v 0 128M" $testdir/f1 | _filter_xfs_io_unique
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/generic/470.out b/tests/generic/470.out
> new file mode 100644
> index 00000000..6d47b219
> --- /dev/null
> +++ b/tests/generic/470.out
> @@ -0,0 +1,13 @@
> +QA output created by 470
> +pwrite: Resource temporarily unavailable
> +wrote 134217728/134217728 bytes at offset 0
> +XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> +RWF_NOWAIT time is within limits.
> +00000000:  aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa  ................
> +*
> +00400000:  bb bb bb bb bb bb bb bb bb bb bb bb bb bb bb bb  ................
> +*
> +00500000:  aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa aa  ................
> +*
> +read 134217728/134217728 bytes at offset 0
> +XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> diff --git a/tests/generic/group b/tests/generic/group
> index 6c3bb03a..11ccfb01 100644
> --- a/tests/generic/group
> +++ b/tests/generic/group
> @@ -472,3 +472,4 @@
>  467 auto quick exportfs
>  468 shutdown auto quick metadata
>  469 auto quick
> +470 auto quick

Perhaps 'rw' group too.

Thanks,
Eryu

> -- 
> 2.14.2
> 
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

^ permalink raw reply	[flat|nested] 6+ messages in thread

* Re: [PATCH v2 3/3] generic/471: Partial direct write test
  2017-11-27 18:49 ` [PATCH v2 3/3] generic/471: Partial direct write test Goldwyn Rodrigues
@ 2017-11-29 10:46   ` Eryu Guan
  0 siblings, 0 replies; 6+ messages in thread
From: Eryu Guan @ 2017-11-29 10:46 UTC (permalink / raw)
  To: Goldwyn Rodrigues; +Cc: fstests, darrick.wong, Goldwyn Rodrigues

On Mon, Nov 27, 2017 at 12:49:20PM -0600, Goldwyn Rodrigues wrote:
> From: Goldwyn Rodrigues <rgoldwyn@suse.com>
> 
> Getting an error midway through a direct write would return an error
> and the error-code is returned in the write() call. However, partial
> data is over-written during the call.
> 
> This tests simulates the ENOSPC error to check for partial direct
> write consistency.
> 
> Signed-off-by: Goldwyn Rodrigues <rgoldwyn@suse.com>
> 
> Changes since v1:
>  - Check for option pwrite -O
>  - Create a 200M file instead of multiple 40M files.
> 
> ---
>  tests/generic/471     | 90 +++++++++++++++++++++++++++++++++++++++++++++++++++
>  tests/generic/471.out |  9 ++++++
>  tests/generic/group   |  1 +
>  3 files changed, 100 insertions(+)
>  create mode 100755 tests/generic/471
>  create mode 100644 tests/generic/471.out
> 
> diff --git a/tests/generic/471 b/tests/generic/471
> new file mode 100755
> index 00000000..a7780af1
> --- /dev/null
> +++ b/tests/generic/471
> @@ -0,0 +1,90 @@
> +#! /bin/bash
> +# FS QA Test No. 471
> +#
> +# write() to a file opened with O_DIRECT with count > remaining
> +# bytes. In case of a bug, the write returns ENOSPC wheras the
> +# showing no data is written, but the file contents are updated.
> +# Result should be the write should return remaining bytes
> +# (to aligned bytes) instead of ENOSPC error.
> +#
> +#-----------------------------------------------------------------------
> +# Copyright (c) 2017, SUSE Linux Products.  All Rights Reserved.
> +#
> +# This program is free software; you can redistribute it and/or
> +# modify it under the terms of the GNU General Public License as
> +# published by the Free Software Foundation.
> +#
> +# This program is distributed in the hope that it would be useful,
> +# but WITHOUT ANY WARRANTY; without even the implied warranty of
> +# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
> +# GNU General Public License for more details.
> +#
> +# You should have received a copy of the GNU General Public License
> +# along with this program; if not, write the Free Software Foundation,
> +# Inc.,  51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
> +#-----------------------------------------------------------------------
> +
> +seq=`basename $0`
> +seqres=$RESULT_DIR/$seq
> +echo "QA output created by $seq"
> +
> +here=`pwd`
> +tmp=/tmp/$$
> +status=1    # failure is the default!
> +trap "_cleanup; exit \$status" 0 1 2 3 15
> +
> +_cleanup()
> +{
> +    cd /
> +    rm -rf $tmp.* $testdir1
> +}
> +
> +# get standard environment, filters and checks
> +. ./common/rc
> +. ./common/populate
> +. ./common/filter
> +. ./common/attr
> +
> +# real QA test starts here
> +_supported_os Linux
> +_require_odirect

Missed _require_scratch

> +_require_xfs_io_command pwrite -O
> +
> +rm -f $seqres.full
> +
> +echo "Reformat with 320M size"
> +umount $SCRATCH_MNT

No need to umount $SCRATCH_MNT, _require_scratch will do it for you.

> +sz_bytes=$((320 * 1024 * 1024))
> +_scratch_mkfs_sized $sz_bytes >> $seqres.full 2>&1
> +_scratch_mount >> $seqres.full 2>&1
> +testdir=$SCRATCH_MNT/test-$seq
> +rm -rf $testdir

No need to remove $testdir here, scratch_dev is freshly created.

> +mkdir $testdir
> +sync
> +
> +#Almost fill the filesystem
   ^^ add a space after '#' for comments

> +echo "Almost fill the filesystem"
> +$XFS_IO_PROG -f -c "pwrite 0 200M" $testdir/f1 > /dev/null
> +
> +# Create a file using buffered I/O which succeeds only partially
> +$XFS_IO_PROG -f -c "pwrite -w -S 0xaa 0 128M" $testdir/partial
> +
> +# re-write using direct I/O with another pattern using one single buffer, once
> +write_size=`$XFS_IO_PROG -d -c "pwrite -O -S 0xcd -V 1 -b 128M 0 128M" $testdir/partial | awk '/^wrote/ {split($2, bytes, "/"); print bytes[1]}'`

Hmm, I can see that "-O" requires bigger block size in this case. Then
how about reserving some space first and fill the rest then remove the
reserved file? So we have a fixed amount of space to do the test. e.g.

# reserve 2m space first
$XFS_IO_PROG -fc "pwrite 0 2m" $testdir/reserve
# fill the rest of the fs
$XFS_IO_PROG -fc "pwrite 0 320m" $testdir/fill
# remove the reserve file to get space free
rm -f $testdir/reserve
...
$XFS_IO_PROG -dc "pwrite -O -S 0xcd -V 1 -b 4m 0 4m" $testdir/partial
...

Thanks,
Eryu

> +if [ -z $write_size ]; then
> +	write_size=0
> +fi
> +
> +# If bug is not fixed, pwrite will return error and but still write data
> +if [ $write_size -gt 0 ]; then
> +	echo "pwrite wrote more than zero bytes."
> +else
> +	echo "pwrite wrote zero bytes"
> +fi
> +
> +# read the partial file to check if data written is of last write
> +$XFS_IO_PROG -c "pread 0 2M -v" $testdir/partial | _filter_xfs_io_unique
> +
> +# success, all done
> +status=0
> +exit
> diff --git a/tests/generic/471.out b/tests/generic/471.out
> new file mode 100644
> index 00000000..e01687c8
> --- /dev/null
> +++ b/tests/generic/471.out
> @@ -0,0 +1,9 @@
> +QA output created by 471
> +Reformat with 320M size
> +Almost fill the filesystem
> +pwrite: No space left on device
> +pwrite wrote more than zero bytes.
> +00000000:  cd cd cd cd cd cd cd cd cd cd cd cd cd cd cd cd  ................
> +*
> +read 2097152/2097152 bytes at offset 0
> +XXX Bytes, X ops; XX:XX:XX.X (XXX YYY/sec and XXX ops/sec)
> diff --git a/tests/generic/group b/tests/generic/group
> index 11ccfb01..f4591620 100644
> --- a/tests/generic/group
> +++ b/tests/generic/group
> @@ -473,3 +473,4 @@
>  468 shutdown auto quick metadata
>  469 auto quick
>  470 auto quick
> +471 auto quick rw
> -- 
> 2.14.2
> 
> --
> To unsubscribe from this list: send the line "unsubscribe fstests" in
> the body of a message to majordomo@vger.kernel.org
> More majordomo info at  http://vger.kernel.org/majordomo-info.html

^ permalink raw reply	[flat|nested] 6+ messages in thread

end of thread, other threads:[~2017-11-29 10:46 UTC | newest]

Thread overview: 6+ messages (download: mbox.gz / follow: Atom feed)
-- links below jump to the message on this page --
2017-11-27 18:49 [PATCH 1/3] Check pwrite parameters Goldwyn Rodrigues
2017-11-27 18:49 ` [PATCH v2 2/3] generic/470: Test RWF_NOWAIT Goldwyn Rodrigues
2017-11-29 10:25   ` Eryu Guan
2017-11-27 18:49 ` [PATCH v2 3/3] generic/471: Partial direct write test Goldwyn Rodrigues
2017-11-29 10:46   ` Eryu Guan
2017-11-29  9:49 ` [PATCH 1/3] Check pwrite parameters Eryu Guan

This is an external index of several public inboxes,
see mirroring instructions on how to clone and mirror
all data and code used by this external index.